*  Program.....: MAKELINK.PRG
*  Authors.....: Peter Volz
*  Copyright(c): 1989-1994 SmartCode Programming, All rights reserved.
*  Application.: BroPlus Professional Xbase Browse Utility & File Manager
*  Version.....: Clipper 5.01 / 5.2
*  Compile.....: clipper makelink /m /n /w
*  Functions...: MakeLink()
*                FetchInput( ary )
*                MakeScript( ary )
*
***************************************************************************

#xcommand Out <cString>   =>    fWrite( i, <cString> + chr(13) + chr(10) )

#define  LINKER           ary[1]
#define  BLVER            ary[2]
#define  BLMODE           ary[3]
#define  HICOLOR          ary[4]
#define  SIXCDX           ary[5]
#define  SIXNSX           ary[6]
#define  SIXNTX           ary[7]
#define  SIXENC           ary[8]
#define  SIXDBT           ary[9]
#define  SIXINTL          ary[10]
#define  SIXNATIO         ary[11]
#define  DBFNSX           ary[12]
#define  MORELIBS         ary[13]
#define  MOREOBJS         ary[14]
#define  REQUESTS         ary[15]

#define LNKFILE   "BROPLUS.LNK"
#define RDDPRG    "RDDRQST.PRG"

#define  TRUE             .t.
#define  FALSE            .f.

*============================================================================

function MakeLink

local lMore    := TRUE
local iChoice1 := 2      // does link script exist?
local iChoice2 := 0      // accept selections?
local ary[15]            // array of input choices

   // Default values
   LINKER      := "B"
   BLVER       := "3"
   BLMODE      := "R"

   HICOLOR     := TRUE

   SIXCDX      := TRUE
   SIXNSX      := TRUE
   SIXNTX      := TRUE
   SIXENC      := FALSE
   SIXDBT      := FALSE
   SIXINTL     := FALSE
   SIXNATIO    := space(10)

   DBFNSX      := FALSE

   MORELIBS    := space(64)
   MOREOBJS    := space(64)
   REQUESTS    := space(64)

   setcolor( "W+/B,W+/R,,,B/W" )
   set scoreboard off
   cls
   @ 0, 0 to maxrow(), maxcol()  // draw box

   if file( LNKFILE )
   
      iChoice1 := Alert( LNKFILE + " exists!; "                        +;
                 "You may either: Bypass link script creation and;"    +;
                 "create BroPlus from the existing link script,;"      +;
                 "or: Overwrite the script, or: Cancel the operation",  ;
                  { "ByPass", "Overwrite", "Cancel"} )

      lMore := iChoice1 == 2  // Enter FetchInput only if "Overwrite"
      
   endif


   @ 2, 25 say "Enter your link options below"

   while lMore

      FetchInput( ary )

      iChoice2 := Alert("Accept Selections?", { "Yes", "No", "Cancel" })

      if iChoice2 % 2 <> 0
         lMore := FALSE
      endif

   end

   lMore := iChoice1 % 3 <> 0  .and. iChoice2 <> 3

   if iChoice2 == 1 .and. MakeScript( ary )

      lMore := Alert("File " + LNKFILE + " & " + RDDPRG +;
             " successfully created!;" + ;
             "Create the BroPlus executable NOW?", { "Yes", "No" } ) == 1
   endif

   if .not. lMore
      ErrorLevel(1)
   endif

   cls

return NIL

*============================================================================

function FetchInput( ary )

local getlist := {}
local i := 4      // screen row

   @ i++, 5 say "Linker to use: <R>tlink / <B>linker / <E>xoSpace (R/B/E) " ;
            get LINKER                                                      ;
            picture "!"                                                     ;
            valid LINKER $ "RBE"

   @ i++, 5 say "Blinker version: <2>.x or <3>.x                    (2/3) " ;
            get BLVER                                                       ;
            valid BLVER $ "23"                                              ;
            when LINKER == "B"

   @ i++, 5 say "If Blinker 3: <R>eal / <E>xtended / <D>ual mode  (R/E/D) " ;
            get BLMODE                                                      ;
            picture "!"                                                     ;
            valid  BLMODE $ "RED"                                           ;
            when LINKER == "B" .and. BLVER == "3"

   @ i++, 5 say "OK to use High-Intensity Background Colors?        (Y/N) " ;
            get HICOLOR                                                     ;
            picture "Y"
   i++

   @ i++, 5 say "Include SIXCDX (CDX indexes, FPT memos)?           (Y/N) " ;
            get SIXCDX                                                      ;
            picture "Y"

   @ i++, 5 say "Include SIXNSX (NSX indexes, SMT memos)?           (Y/N) " ;
            get SIXNSX                                                      ;
            picture "Y"

   @ i++, 5 say "Include SIXNTX (NTX indexes, DBT memos)?           (Y/N) " ;
            get SIXNTX                                                      ;
            picture "Y"
                 
   @ i++, 5 say "Support SIx Driver data encryption / decryption?   (Y/N) " ;
            get SIXENC                                                      ;
            picture "Y"                                                     ;
            when SIXCDX .or. SIXNSX .or. SIXNTX

   @ i++, 5 say " (Not recommended since it slows down Browse speed)"

   @ i++, 5 say "Replace native SIx Memo support with .DBT memos?   (Y/N) " ;
            get SIXDBT                                                      ;
            picture "Y"                                                     ;
            when SIXCDX .or. SIXNSX

   @ i++, 5 say "Use International version of the SIx Driver?       (Y/N) " ;
            get SIXINTL                                                     ;
            picture "Y"                                                     ;
            when SIXCDX .or. SIXNSX .or. SIXNTX

   @ i++, 5 say "Enter name of your nation module, e.g. 'SIXGER.OBJ'   => " ;
            get SIXNATIO                                                    ;
            picture "@!"                                                    ;
            when SIXINTL
   i++

   @ i++, 5 say "Include DBFNSX Rdd - HiPer-SIx?                    (Y/N) " ;
            get DBFNSX                                                      ;
            picture "Y"                                                     ;
            when .not. SIXNSX
   i++

   @ i++, 5 say "Additional LIBs if any, separated by comma  =>"            ;
            get MORELIBS                                                    ;
            picture "@!S25"

   @ i++, 5 say "Additional OBJs if any, separated by comma  =>"            ;
            get MOREOBJS                                                    ;
            picture "@!S25"

   @ i++, 5 say "EXTERNAL references if any, sep. by comma   =>"            ;
            get REQUESTS                                                    ;
            picture "@S25"
   read

return NIL

*============================================================================

function MakeScript( ary )

local i     // file handle for BROLINK.LNK & RDDRQST.PRG
local cDef  // default RDD if not DBFNTX

if ( i := fCreate( LNKFILE, 0 ) ) == -1
   Alert( "Error creating link file" )
   return FALSE
endif

// Header
Out "## " + LNKFILE
Out "##"
Out "## BroPlus Database Browse Utility System, Version 2.50-sx"
Out "## " + dtoc( date() ) + "  " + time()
Out "## Copyright(c) 1989-1994 SmartCode Programming, All rights reserved."
Out "##"
Out "## Custom linker response file"
Out "##"

// script content
if LINKER == "B"  // Blinker

   Out    "BLINKER INCREMENTAL OFF"
   Out    "BLINKER EXECUTABLE CLIPPER F65;CGACURS;BADCACHE"
   Out    "BLINKER MESSAGE NOBLINK"
   Out    "BLINKER OVERLAY UMB ON"
   Out    "BLINKER OVERLAY PAGEFRAME ON"
   Out    ""

   if BLVER == "3"
    if BLMODE == "E"
      Out "BLINKER EXECUTABLE EXTENDED"
    elseif BLMODE == "D"
      Out "BLINKER EXECUTABLE DUAL"
    endif
   endif

elseif LINKER == "E" // ExoSpace

   Out    "EXOSPACE EXECUTABLE CLIPPER F65;CGACURS;BADCACHE"
   Out    ""

else                 // Rtlink nothing is needed
endif

// create map file
if LINKER $ "BE"
   Out    "MAP S,A"
endif

Out       "OUTPUT BRO"

// Stack setting for SIx
Out    "STACK 7168"
Out       ""

// Full- or Run-Time version
Out    "FILE BRO"

// SIx driver and DBT memos
if SIXDBT
   Out "FILE DBT"
endif
// SIx driver international
if SIXINTL .and. .not. empty( SIXNATIO )
   Out "FILE " + SIXNATIO
endif

if LINKER == "B"
   Out    "MOD tbrowse0"
   Out    "MOD tbrowse1"
   Out    "MOD linelen"
   Out    ""

   // Blinker Dual mode
   if BLVER == "3" .and. BLMODE == "D"
      Out "SECTION INTO BRO.OVL"
   endif

   Out    "BEGINAREA"

endif

// Startup @ Rdd requests
Out       "FILE STARTUP"
Out       "FILE RDDRQST"

// Colors
if HICOLOR
   Out    "FILE BROCOLOR"
else
   Out    "FILE BROCOLNB"
endif

// standard libs
Out    "LIB BROPL52"
Out    "LIB CALC"

// SuccessWare stuff
if SIXCDX .or. SIXNSX .or. SIXNTX

   if SIXENC
      Out "FILE BROSXENC"
   endif

   Out    "FILE BROSIX"

   if SIXNSX .and. .not. SIXCDX
      Out "FILE BNOSXCDX"
   endif

else

   // No SIx Driver (but DBFNSX)
   Out    "FILE BRONOSIX"

endif

// Swap stuff
if LINKER == "B"
   Out    "FILE BROSWAP"
else
   Out    "FILE BRNOSWAP"
endif

// Additional Object files?
if .not. empty( MOREOBJS )
   Out    "FILE " + trim( MOREOBJS )
endif

if LINKER == "B"

   Out "ENDAREA"
   Out ""

   if BLVER == "3" .and. BLMODE $ "ED"

      // Blinker Extended/Dual
      Out "SEARCH BLXCLP52"
      // Out "SEARCH BLXRATEX"   // is probably not required

   endif

   // Clipper overlay scripts
   Out "@CL520MID.LNK"

endif

// Rdd overlay scripts
if LINKER == "B"

   if SIXCDX .or. SIXNSX .or. SIXNTX
         Out "@SIX3.LNK"
   endif

   if DBFNSX
      Out "@DBFNSX.LNK"
   endif

else

   // Rdd libraries
   if SIXCDX .or. SIXNSX .or. SIXNTX
      Out "LIB SIX3"
   endif

   if DBFNSX
      Out "LIB DBFNSX"
   endif

endif

// Additional Libraries?
if .not. empty( MORELIBS )
   Out    "LIB " + trim( MORELIBS )
endif

Out       ""
Out       "## End of " + LNKFILE

fClose(i)

*----------------------------------------------------------------------------
// write RDDRQST.PRG (driver requests, and custom requests (externals)
if ( i := fCreate( RDDPRG, 0 ) ) > -1

   Out "// RDD requests & default RDD selection"
   Out "// " + dtoc( date() ) + "  " + time()

   Out "function RddRqst"

   if DBFNSX
      Out "request DBFNSX"
   endif
   if SIXNTX
      Out "request SIXNTX"
   endif
   if SIXCDX
      Out "request SIXCDX"
   endif
   if SIXNSX
      Out "request SIXNSX"
   endif

   if .not. empty( REQUESTS )
      Out "request " + trim( REQUESTS )
   endif

   Out "return NIL"

   if SIXCDX
      cDef := "SIXCDX"
   elseif SIXNSX
      cDef := "SIXNSX"
   elseif SIXNTX
      cDef := "SIXNTX"
   elseif DBFNSX        //need to inherit from DBFNTX Rdd
      cDef := "DBFNTX"
   endif
   Out ""
   Out "INIT Procedure RddInit"
   Out "announce RDDSYS"
   Out "request " + cDef
   Out "RddSetDefault( '" + cDef + "' )"
   if LINKER == "E"
      Out "ExoGPInstall()"
   endif
   Out    "return"

   fClose(i)

endif
*----------------------------------------------------------------------------
// write batch file to compile RddRqst.prg & link BroPlus.lnk
if ( i := fCreate( "MAKEBRO.BAT", 0 ) ) > -1

   Out "REM " + dtoc( date() ) + "  " + time()

   Out "clipper RddRqst /m/n/a/w"
   Out "clipper StartUp /m/n/a/w"

   if LINKER == "B"
      Out "Blinker @BroPlus"
   elseif LINKER == "E"
      Out "ExoSpace @BroPlus"
   else
      Out "RTLink @BroPlus"
   endif

   fClose(i)

endif

return TRUE

*============================================================================
