/*
  ķ
                                                                         
   Program...: FPT2SMT.PRG                                               
   Author....: Team SuccessWare                                          
   Notice....: Copyright 1993-95 - SuccessWare 90, Inc.                  
   Purpose...: This is a simple program demonstrating how to convert The 
               SIx Driver (SIXCDX) .FPT memo files into SIx Driver       
               (SIXNSX) .SMT's uing a simple COPY TO routine.            
                                                                         
   Compile...: CLIPPER fpt2smt /n/w                                      
   Link......: BLINKER FI fpt2smt,sixnsx LI six3                         
                                                                         
  Ľ
*/

REQUEST SIXCDX

FUNC FPT2SMT( cOldFile, cNewFile )

LOCAL aFile := {}

// Display a message
? "FPT2SMT - Memo File Converter"
?

// Make sure we got the correct parameters
IF PCOUNT() < 2
  ? " USAGE:  FPT2SMT <OldFile> <NewFile>"
  ?
  ? " where:  <OldFile> = Name of the database containing the memo"
  ? "                     field to convert."
  ? "         <NewFile> = New file to create."
  ?
  ? "    Ex:  FPT2SMT test test2"
  ?
  ? "  NOTE:  This creates a new DBF and SMT file.  Both new files must be"
  ? "         used together."
  ?
  Return(1)
ENDIF

cOldFile := Upper( AllTrim( cOldFile ))
cNewFile := Upper( AllTrim( cNewFile ))

IF "." $ cOldFile
  cOldFile := Left( cOldFile, at( ".", cOldFile )-1 )
ENDIF

IF "." $ cNewFile
  cNewFile := Left( cNewFile, at( ".", cNewFile )-1 )
ENDIF

IF cOldFile == cNewFile
  Alert( "ERROR: Source and destination;" +;
         "file names MUST be different!")
  Quit
ENDIF

// Check for the original file
IF !File( cOldFile + ".DBF" )
  ? "Cannot find " + cOldFile + "!"
  ?
  Return(2)
ENDIF

// Open the original file (using SIXCDX)
USE (cOldFile) VIA "SIXCDX"

// Show that we're doing something
? "Working"

// Now copy to the new file (with nifty UDF)
COPY TO (cNewFile) FOR ShowDot()

// Look, we made it!
?? "Done!"
?

// Clean up before leaving
CLOSE ALL

// Compare file sizes
aFile := Directory( cOldFile + ".FPT" )
? PadR( "Old " + cOldFile + ".FPT Size",21 ) + ": "
?? Str( aFile[1,2] ) + " bytes"
aFile := Directory( cNewFile + ".SMT" )
? PadR( "New " + cNewFile + ".SMT Size",21 ) + ": "
?? Str( aFile[1,2] ) + " bytes"
?

Return(0)

FUNC ShowDot()
  ?? "."
Return (.T.)
