/*
  ķ
                                                                         
   Program...: HSFILT.PRG                                                
   Author....: Team SuccessWare                                          
   Notice....: Copyright 1995 - SuccessWare 90, Inc.                     
   Purpose...: Demonstrates using SIx 3.0's HiPer-SEEK indexes for fast  
               filtered browses of values in various fields.             
                                                                         
   Compile...: CLIPPER hsfilt /n/w                                       
   Link......: BLINKER FI hsfilt, sixnsx @six3                           
                                                                         
   NOTES:  The example requires a TEST.DBF file of any size, which must  
           be created with our DBCRE8.EXE utility.  For example, to      
           create a TEST.DBF file with 5000 records, you would type this 
           at the DOS command-line:                                      
                                                                         
               C:\> DBCRE8 5000                                          
                                                                         
  Ľ
*/

#include "common.ch"
#include "inkey.ch"

FUNC hsFilt()

LOCAL nCount := 0
LOCAL cExpr := "test->FIRST + test->LAST + test->STREET + test->CITY"
LOCAL nTime := 0, lStrict := .F., h := 0
LOCAL cSearch := "Steve John Robert"
LOCAL GetList := {}

SET SCOREBOARD OFF

CLS
IF !file( "TEST.DBF" )
  Alert( "Missing TEST.DBF" )
  QUIT
ENDIF
USE test EXCL

IF !file("test.hsx")
  ? "Record Count: ", LTrim( Str( LastRec()))
  ?
  ? "Building HiPer-SEEK Index..."
  nTime := seconds()
  h := hs_Index( "test.hsx", cExpr, 2 )
  ?? "Done!  (" + LTrim( Str( seconds()-nTime )) + " seconds)"
  hs_Close( h )
  WAIT
  CLS
ENDIF

SetCursor(1)
WHILE .T.
  cSearch := PadR( cSearch, 59 )
  @ 0,0 SAY "Search Values.....:" GET cSearch
  @ 1,0 SAY "Strict Match (Y/N):" GET lStrict PICTURE "Y"
  READ
  IF LastKey() == K_ESC
    CLS
    EXIT
  ENDIF
  cSearch := AllTrim( cSearch )

  @ 3,0 SAY "Setting HiPer-SEEK Filter ..."
  nTime := seconds()

  nCount := hs_Filter( "test.hsx", cSearch, iif( lStrict, cExpr, "" ))

  ?? "Done!  (" + LTrim( Str( seconds()-nTime )) + " seconds)  "
  @ 4,0 SAY LTrim( Str( nCount )) + " records meeting filter condition."

  @ 6,0 SAY "Press any key to browse the matching records..."
  inkey(0)

  GO TOP
  browse()
  CLS
ENDDO

CLOSE ALL
fErase( "TEST.HSX" )

Return(NIL)

