/*
͸
 Source file: SIXDEMO.PRG                                                 
 Description: Sample program to demonstrate SIx Driver v3.0 features.     
 Written by : Team SuccessWare                                            
 Notice     : Copyright 1993-95 - SuccessWare 90, Inc.                    
                                                                          
  Compile:  CLIPPER sixdemo  /n /w                                        
  Compile:  CLIPPER hsfilt   /n /w                                        
  Compile:  CLIPPER sixtools /n /w                                        
  Compile:  CLIPPER scope    /n /w                                        
  Compile:  CLIPPER ryodemo  /n /w                                        
  Compile:  CLIPPER scrllbar /n /w                                        
  Compile:  CLIPPER multikey /n /w                                        
  Compile:  CLIPPER rollback /n /w                                        
  Compile:  CLIPPER memoconv /n /w                                        
  Compile:  CLIPPER trigdemo /n /w                                        
  Compile:  CLIPPER inidemo  /n /w                                        
  Compile:  CLIPPER m6demo   /n /w                                        
  Compile:  CLIPPER ryofilt  /n /w                                        
                                                                          
  Link:  BLINKER FI sixdemo @sixdemo                                      
                                                                          
 NOTE: The MAKEDEMO.BAT file will compile, link, and run the SIXDEMO      
       program for you automatically, assuming that all of the required   
       executable files (CLIPPER.EXE, DBCRE8.EXE, and your selected       
       libraries, OBJ's, and header files are in your environment paths.  
                                                                          
       MAKEDEMO.BAT also provides support for ExoSpace and CauseWay.      
                                                                          
;
  
*/


#ifdef CDX
  #include "SIXCDX.CH"
  #define RDDNAME "SIXCDX"
  #define MEMOEXT ".FPT"
  #define INDEXEXT ".CDX"
#else
  #include "SIXNSX.CH"
  #define RDDNAME "SIXNSX"
  #define MEMOEXT ".SMT"
  #define INDEXEXT ".NSX"
#endif

#include "INKEY.CH"
#include "BOX.CH"
#include "DIRECTRY.CH"

#define TRUE  .T.
#define FALSE .F.

#define ROW  3
#define COL  5

FUNC SIxDemo( cParam )

LOCAL lMore := TRUE, nCount := 0, lEverything := FALSE, lRefresh := FALSE
LOCAL cOldColor := SetColor("bg+/n"), nMemoPos := 0, nMaxCol := MaxCol()
LOCAL nCurs := SetCursor(0), nTemp := 0, nMaxRow := MaxRow()
LOCAL aDemo := {}, nX := 0, nY := 0, nKey := 0, nKey2 := 0, nRow := 0
LOCAL lNoAlert := iif( PCount() > 0 .and. upper(cParam)=="NOALERT",;
                  TRUE, FALSE )
LOCAL aMemo := {}, cMemScr := "", nOldnX := 0

// No RLock()'s Required...
SET EXCLUSIVE ON

// Check for databases
CLS

IF !file( "TEST5K.DBF" ) .or. !file( "TEST.DBF" ) .or. ;
   !file( "TESTOLD.DBF" ) .or. !file( "TEST500.DBF" )
   SchmoozeBox( "Missing one or more required DBF files!;;" +;
                "Restart demo using RUNDEMO.BAT.", lNoAlert )
  QUIT
ENDIF

SetColor("w+/b,w+/w,,,b/w")
SetBlink(FALSE)

// Make The SIx Driver the Default
SetRDD( RDDNAME )

DO WHILE lMore
  CLS

  aDemo := {{ "", " Compact Indexes",;
              {|| SIx_Compact( lNoAlert )}},;
            { "", " Compound Indexes",;
              {|| SIx_Compound( lNoAlert )}},;
            { "", " Conditional & Sub-Indexes",;
              {|| SIx_Conditional( lNoAlert )}},;
            { "", " SCOPEd Indexes",;
              {|| SIx_Scope( lNoAlert )}},;
            { "", " Roll-Your-Own (RYO) Indexes",;
              {|| SIx_RYO( lNoAlert )}},;
            { "", " Multi-Keyed, Free-Format Indexes",;
              {|| SIx_MultiKeyed( lNoAlert )}},;
            { "", " VariField Data Storage",;
              {|| SIx_VariField( lNoAlert )}},;
            { "", " HiPer-SEEK Indexes & Filters",;
              {|| SIx_HiPerSEEK( lNoAlert )}},;
            { "", " The Mach SIx Query Optimizer",;
              {|| SIx_MachSIx( lNoAlert )}},;
            { "", " " + MEMOEXT + " Memo File Stuff            ",;
              {|| SIx_Memo( aMemo, lNoAlert )}},;
            { "", " Record Edit Rollbacks",;
              {|| SIx_RollBack( lNoAlert )}},;
            { "", " Logical Index Key Functions",;
              {|| SIx_LogicalKey( lNoAlert )}},;
            { "", " Data/File Compression Features",;
              {|| SIx_Compress( lNoAlert )}},;
            { "", " Data/File Encryption Features",;
              {|| SIx_Encrypt( lNoAlert )}},;
            { "", " Database Triggers",;
              {|| SIx_Triggers( lNoAlert )}},;
            { "", " Data Dictionary (.INI) Features",;
              {|| SIx_DBINI( lNoAlert )}},;
            { "", " Miscellaneous SIx Driver Features",;
             {|| SIx_Misc( lNoAlert )}};
           }

  aMemo := {{ "", " Smaller Than DBT Memos ",;
              {|| Mem_Convert( lNoAlert )}},;
            { "", " Adjustable Block Size ",;
              {|| Mem_BlockSize( lNoAlert )}},;
            { "", " Reuse Of Freed Blocks ",;
              {|| Mem_FreeBlocks( lNoAlert )}},;
            { "", " Memo Packing ",;
              {|| Mem_Pack( lNoAlert )}};
           }

  // Save aDemo{} element number which contains Memo sub-menu
  FOR nTemp := 1 TO Len( aDemo )
    IF "" $ aDemo[ nTemp,2 ]
      nMemoPos := nTemp
      EXIT
    ENDIF
  NEXT

  DispBox( ROW+1, COL+1, ROW+Len(aDemo)+2, COL+40,, "n/n" )
  DispBox( ROW, COL, ROW+Len(aDemo)+1, COL+39, B_DOUBLE+" ", "r/w*" )

  FOR nX := 1 TO Len( aDemo )
    @ nX+ROW,COL+3 SAY aDemo[nX,1] COLOR "r/w*"
    @ nX+ROW,COL+4 SAY aDemo[nX,2] COLOR "b/w*"
  NEXT

  @  0, 0 SAY Replicate( " ", nMaxCol+1 ) COLOR "n/w*"
  @  0, 3 SAY "SIx Driver (" + RDDNAME + ") v" + Sx_Version() +;
              " Demo Program    (c)1995 SuccessWare 90, Inc." COLOR "r/w*"

  @ nMaxRow, 0 SAY Replicate( " ", nMaxCol+1 ) COLOR "r/w*"
  @ nMaxRow, 1 SAY " <SPACE> = Tag/Untag (F10=ALL) " COLOR "r/w*"
  @ nMaxRow,35 SAY " <ENTER> = Begin Demo " COLOR "r/w*"
  @ nMaxRow,65 SAY " <ESC> = Quit " COLOR "r/w*"


  nX := 1

  DO WHILE TRUE

    lRefresh := FALSE
    @ nX+ROW,COL+1 SAY "" COLOR "n/w*"
    nKey := inkey(0)
    @ nX+ROW,COL+1 SAY " " COLOR "b/w*"

    DO CASE

      CASE nKey == K_ESC
        lMore := FALSE
        EXIT

      CASE nKey == K_ENTER
        nCount := 0
        FOR nTemp := 1 TO Len( aDemo )
          iif( aDemo[nTemp,1] == "", eval( aDemo[nTemp,3] ), NIL )
          nCount += iif( aDemo[nTemp,1] == "", 1, 0 )
        NEXT
        IF nCount == 0
          IF nX == nMemoPos
            aDemo[nX,1] := ""
            @ nX+ROW,COL+3 SAY aDemo[nX,1] COLOR "r/w*"
            lRefresh := TRUE
          ELSE
            eval( aDemo[nX,3] )
          ENDIF
        ENDIF
        IF !lRefresh
          EXIT
        ENDIF

      CASE nKey == K_SPACE
        aDemo[nX,1] := iif( aDemo[nX,1] == "", "", "" )
        @ nX+ROW,COL+3 SAY aDemo[nX,1] COLOR "r/w*"

      CASE nKey == K_F10
        IF lEverything
          FOR nTemp := 1 TO Len( aDemo )
            aDemo[ nTemp, 1 ] := ""
            @ nTemp+ROW,COL+3 SAY aDemo[nTemp,1] COLOR "r/w*"
          NEXT
          FOR nTemp := 1 TO Len( aMemo )
            aMemo[ nTemp, 1 ] := ""
            @ nTemp+ROW,COL+3 SAY aMemo[nTemp,1] COLOR "r/w*"
          NEXT
          lEverything := FALSE
        ELSE
          FOR nTemp := 1 TO Len( aDemo )
            aDemo[ nTemp, 1 ] := ""
            @ nTemp+ROW,COL+3 SAY aDemo[nTemp,1] COLOR "r/w*"
          NEXT
          FOR nTemp := 1 TO Len( aMemo )
            aMemo[ nTemp, 1 ] := ""
            @ nTemp+ROW,COL+3 SAY aMemo[nTemp,1] COLOR "r/w*"
          NEXT
          lEverything := TRUE
        ENDIF
        lRefresh := TRUE

      CASE nKey == K_UP
        nX := iif( nX == 1, Len( aDemo ), nX-1 )

      CASE nKey == K_DOWN
        nX := iif( nX == Len( aDemo ), 1, nX+1 )

    ENDCASE


    IF "" $ aDemo[nX,2] .OR. lRefresh

      nOldnX := nX
      IF lRefresh
        nX := nMemoPos
      ENDIF

      IF aDemo[nX,1] == ""

        IF empty( cMemScr )
          cMemScr := SaveScreen( nX+ROW-1, COL+40, nX+ROW+Len(aMemo)+1, COL+72 )
        ENDIF

        DispBox( nX+ROW, COL+41, nX+ROW+Len(aMemo)+1, COL+72,, "n/n" )
        DispBox( nX+ROW-1, COL+40, nX+ROW+Len(aMemo), COL+71, B_SINGLE+" ", "r/w*" )

        FOR nY := 1 TO Len( aMemo )
          @ nY+nX+ROW-1,COL+43 SAY aMemo[nY,1] COLOR "r/w*"
          @ nY+nX+ROW-1,COL+44 SAY aMemo[nY,2] COLOR "b/w*"
        NEXT

        // Determine starting position of selector, depending on last key
        nY := iif( nKey == K_UP, Len( aMemo ), 1 )

        DO WHILE TRUE

          @ nY+nX+ROW-1,COL+41 SAY "" COLOR "n/w*"
          nKey2 := inkey(0)
          @ nY+nX+ROW-1,COL+41 SAY " " COLOR "n/w*"

          DO CASE

            CASE nKey2 == K_ESC
              EXIT

            CASE nKey2 == K_ENTER
              nCount := 0
              FOR nTemp := 1 TO Len( aDemo )
                iif( aDemo[nTemp,1] == "", eval( aDemo[nTemp,3] ), NIL )
                nCount += iif( aDemo[nTemp,1] == "", 1, 0 )
              NEXT
              IF nCount == 1
                eval( aMemo[nY,3] )
              ENDIF
              EXIT

            CASE nKey2 == K_SPACE
              aMemo[nY,1] := iif( aMemo[nY,1] == "", "", "" )
              @ nX+nY+ROW-1,COL+43 SAY aMemo[nY,1] COLOR "r/w*"
              nY := iif( nY == Len( aMemo ), 1, nY+1 )

            CASE nKey2 == K_F10
              IF lEverything
                FOR nTemp := 1 TO Len( aDemo )
                  aDemo[ nTemp, 1 ] := ""
                  @ nTemp+ROW,COL+3 SAY aDemo[nTemp,1] COLOR "r/w*"
                NEXT
                FOR nTemp := 1 TO Len( aMemo )
                  aMemo[ nTemp, 1 ] := ""
                  @ nTemp+ROW,COL+3 SAY aMemo[nTemp,1] COLOR "r/w*"
                NEXT
                RestScreen( nX+ROW-1, COL+40, nX+ROW+Len(aMemo)+1, COL+72, cMemScr )
                lEverything := FALSE
                EXIT
              ELSE
                FOR nTemp := 1 TO Len( aDemo )
                  aDemo[ nTemp, 1 ] := ""
                  @ nTemp+ROW,COL+3 SAY aDemo[nTemp,1] COLOR "r/w*"
                NEXT
                FOR nTemp := 1 TO Len( aMemo )
                  aMemo[ nTemp, 1 ] := ""
                  @ nTemp+ROW,COL+3 SAY aMemo[nTemp,1] COLOR "r/w*"
                NEXT
                lEverything := TRUE
              ENDIF
              lRefresh := TRUE

            CASE nKey2 == K_UP
              nY := iif( nY == 1, Len( aMemo ), nY-1 )

            CASE nKey2 == K_DOWN
              nY := iif( nY == Len( aMemo ), 1, nY+1 )

          ENDCASE
        ENDDO
      ELSE
        FOR nY := 1 TO Len( aMemo )
          aMemo[nY,1] := ""
        NEXT
        IF !empty( cMemScr )
          RestScreen( nX+ROW-1, COL+40, nX+ROW+Len(aMemo)+1, COL+72, cMemScr )
        ENDIF
      ENDIF
      nX := nOldnX
    ENDIF

    // If ENTER was pressed from within MEMO options window, Clean up
    IF nKey2 == K_ENTER
      nKey2 := 0
      EXIT
    ENDIF

    // If SPACE bar was pressed move selector down one row
    IF nKey == K_SPACE
      nX := iif( nX == Len( aDemo ), 1, nX+1 )
    ENDIF

  ENDDO
ENDDO

CLS
SchmoozeBox("For more information, or to purchase;" +;
      "The SuccessWare Index (SIx) Driver ;;" +;
      "Call (800) 683-1657;" +;
      "  or (909) 699-9657;" +;
      "FAX  (909) 695-5679", lNoAlert)

SetColor( cOldColor )
SetCursor( nCurs )
CLS

Return(NIL)


/*
 ͸
   SchmoozeBox() - Provides ability to Alert() or not based on lDisplay val
 ;
*/

FUNC SchmoozeBox( cText, lNoSchmooze )

IF !lNoSchmooze
  Alert( cText, NIL, "b/w*" )
ENDIF

Return(NIL)


/*
 ͸
   Compact Indexes                                                         
 ;
*/

FUNC SIx_Compact( lNoAlert )

LOCAL nCol := 0, aFiles := {}, nX := 0
FIELD last

CLS
MyAlert( RDDNAME + " Indexes Are Compact!" )
USE TEST VIA "DBFNTX"
? "Creating LAST.NTX on LAST field (20 chars):"
? ""
?
#ifdef CLIP501
? "INDEX ON last TO last"
#else
? "INDEX ON last TO last EVAL Dots( nCol ) EVERY 10 "
#endif

nCol := Col()
INDEX ON last TO last EVAL Dots( nCol ) EVERY 10

?
WAIT
CLS
CLOSE ALL

USE TEST
? "Creating LAST" + OrdBagExt() + " on LAST field (20 chars):"

? ""
?
? "INDEX ON last TO last EVAL Odometer() EVERY 10 "
INDEX ON last TO last EVAL Odometer() EVERY 10

CLOSE ALL
CLS
aFiles := Directory("LAST.*")
FOR nX := 1 TO Len( aFiles )
  IF aFiles[nX,F_NAME] == "LAST.NTX"
    ? "Size of LAST.NTX: " + AllTrim( Str( aFiles[nX,F_SIZE] )) + " Bytes"
  ELSEIF aFiles[nX,F_NAME] == "LAST" + OrdBagExt()
    ? "Size of LAST" + OrdBagExt() + ": " + AllTrim( Str( aFiles[nX,F_SIZE] )) + " Bytes"
  ENDIF
NEXT
?
WAIT

SchmoozeBox("If all you want is smaller, faster;" +;
      "indexes,  then you don't even need;" +;
      "to re-compile!                    ", lNoAlert)

?
?
? "Without " + RDDNAME + "..."
? "C:> BLINKER FI YourApp  LIB CLIPPER, ..."
?
? "With " + RDDNAME + "..."
? "C:> BLINKER FI YourApp, " + RDDNAME + "  @SIX3  LIB CLIPPER, ..."
?
WAIT

Return(NIL)


/*
 ͸
   Compound Indexes                                                        
 ;
*/

FUNC SIx_Compound( lNoAlert )

LOCAL nX := 0, nCol := 0

CLS
MyAlert("" + INDEXEXT + " Indexes Are Compound!")
SchmoozeBox("If  you  need to save file handles or  get  around;" +;
            "Clipper's  15 indexes-per-workarea limit,  you can;" +;
            "use  compound (" + INDEXEXT + ") indexes.   You can have up to;" +;
            "50  index  'tags' within each " + INDEXEXT + " file,  and  you;" +;
            "can still have up to 15 " + INDEXEXT + " indexes open for each;" +;
            "workarea!                                         ", lNoAlert );

SchmoozeBox("First let's create four separate NTX files...", lNoAlert)

USE TEST VIA "DBFNTX"
@ 1,0 SAY 'USE TEST VIA "DBFNTX"'

#ifdef CLIP501
FOR nX := 1 TO 4
  @ nX+2,0 SAY "INDEX ON " + PadR( FieldName(nX), 6 ) + " TO " +;
                PadR( FieldName(nX), 6 )
  nCol := Col()
  INDEX ON &(FieldName(nX)) TO (FieldName(nX))
NEXT
#else
FOR nX := 1 TO 4
  @ nX+2,0 SAY "INDEX ON " + PadR( FieldName(nX), 6 ) + " TO " +;
                PadR( FieldName(nX), 6 ) + " EVAL Dots( nCol ) EVERY 10 "
  nCol := Col()
  INDEX ON &(FieldName(nX)) TO (FieldName(nX)) EVAL Dots( nCol ) EVERY 10
NEXT
#endif

SchmoozeBox("To create compound indexes instead, all you;" +;
            "have to do is change the word TO to TAG  in;" +;
            "the INDEX command...                       ", lNoAlert )

CLOSE ALL
@ 1,0 SAY 'USE TEST VIA "' + RDDNAME + '"'
USE TEST VIA RDDNAME
FOR nX := 1 TO 4
  @ nX+2,0 SAY Space(80)
  @ nX+2,0 SAY "INDEX ON " + PadR( FieldName(nX), 6 ) + " TAG " +;
                PadR( FieldName(nX), 6 ) + " EVAL Dots( nCol ) EVERY 10 "
  nCol := Col()
  INDEX ON &(FieldName(nX)) TAG (FieldName(nX)) EVAL Dots( nCol ) EVERY 10
NEXT
IF lNoAlert
  @MaxRow()-5,0 SAY "REINDEX EVAL Odometer() EVERY 50"
ELSE
  MyAlert("REINDEX EVAL Odometer() EVERY 50")
ENDIF
REINDEX EVAL Odometer() EVERY 50
CLOSE ALL

// Perform Clean-up
fErase( "FIRST.NTX" )
fErase( "LAST.NTX" )
fErase( "STREET.NTX" )
fErase( "CITY.NTX" )
fErase( "TEST" + INDEXEXT )

Return(NIL)

/*
 ͸
  Conditional Index / Sub-Index Demo                                       
 ;
*/

FUNC SIx_Conditional( lNoAlert )

LOCAL nCol := 0, nKeys := 0
FIELD first, last

CLS
MyAlert("Conditional Index / Filter Demo")
USE TEST5K
SchmoozeBox("First we'll open a 5,000 record table;" +;
            "and SET FILTER to LAST = 'Jo'.  Try a;" +;
            "few Page-Ups and Page-Downs...       ", lNoAlert)

// Make sure Mach SIx doesn't optimize this filter
m6_Set( 2, FALSE )

SET FILTER TO LAST = "Jo"
dbGoTop()
Browse()
SchmoozeBox("Perty slow, huh?", lNoAlert)
SchmoozeBox("Next, we'll turn off the filter and;" +;
            "build  an INDEX which contains  the;" +;
            "same filter INSIDE its index key...", lNoAlert)
SET FILTER TO

INDEX ON last TO filtdemo FOR last = "Jo" EVAL Odometer() EVERY 50
Browse()
CLS
SchmoozeBox("Serious speed difference!", lNoAlert)

CLS
MyAlert("SUBINDEX Demo")
SchmoozeBox("Let's re-sort the data SET from that last demo.;" +;
            "This time it'll be alphabetical on FIRST name. ", lNoAlert)
? "Creating SUBINDEX: "
nCol := Col()
nKeys := Sx_KeyCount()
SUBINDEX ON first TO tfirst EVAL Odometer(nKeys)
SchmoozeBox("Since we only looked at the CURRENT set, the;" +;
            "creation of this SUB-INDEX was very fast.   ", lNoAlert)
Browse()
CLOSE ALL

// Perform clean-up
fErase( "FILTDEMO" + OrdBagExt() )
fErase( "TFIRST" + OrdBagExt() )

CLS

// Turn Mach SIx back on
m6_Set( 2, TRUE )

Return(NIL)

/*
 ͸
  SCOPEd Index Demo                                                        
 ;
*/

FUNC SIx_Scope( lNoAlert )

CLS
MyAlert("SCOPED Index Demo")
SchmoozeBox("In the SUBINDEX example, a conditional index was;" +;
            "required before you could build a SUB index.    ", lNoAlert)
SchmoozeBox("With SCOPEd indexes, you can SET the;" +;
            "SCOPE on-the-fly, effectively giving;" +;
            "you an instantaneous INDEX FILTER.  ", lNoAlert)

ScopeDemo()

Return(NIL)

/*
 ͸
  Roll-Your-Own (RYO) Indexes                                              
 ;
*/

FUNC SIx_RYO( lNoAlert )

CLS
MyAlert("Roll-Your-Own (RYO) Index Demo")
SchmoozeBox("Perhaps  you  are currently using a  logical  field;" +;
            "in  your database to indicate if a record should be;" +;
            "included in a process (i.e., a report).   You might;" +;
            "have a hot-key set up in your browse that your user;" +;
            "presses to toggle that record between TRUE & FALSE.", lNoAlert )

SchmoozeBox("Instead of taking up one byte for each record in your;" +;
            "database,  you can use an RYO index.   When the  user;" +;
            "hits that hot-key,  you just Sx_KeyAdd() that  record;" +;
            "into the RYO!  Less disk space and MUCH faster!      ", lNoAlert )

RYODemo()

Return(NIL)


/*
 ͸
   Multi-Keyed, Free-Format RYO Indexes                                    
 ;
*/

FUNC SIx_MultiKeyed( lNoAlert )

CLS
MyAlert("Multi-Keyed, Free-Format RYO Index Demo")
SchmoozeBox("You can take the RYO index idea one step further;" +;
            "and use the Multi-Keyed, Free-Format RYO indexes;" +;
            "to do powerful things like:                     ;;"+;
            "    SEEK on key words from a memo field        ;" +;
            "    Create spell-checker dictionaries          ;" +;
            "    Add an index key for every word in a field ;" +;
            "    Store data directly in the index file      ;" +;
            "    Create context-sensitive help systems      ", lNoAlert )

SchmoozeBox("This  next demonstration uses a Multi-Keyed RYO;" +;
            "index to 'automatically' add and maintain a key;" +;
            "for  every word in the NAME field.   Additional;" +;
            "keywords can be added or dropped just by  using;" +;
            "a hot-key.                                     ", lNoAlert )

MultiKey()

Return(NIL)


/*
 ķ
  Vari-Fields (tm)                                                         
 Ľ
*/

FUNC SIx_VariField( lNoAlert )

LOCAL aDBF := {{"TEST","M",10,0}}, nX := 0

CLS
CLOSE ALL
MyAlert("VariField Data Storage")

SchmoozeBox("Under SIx 2.0, VariField's implied the ability to;" +;
            "store variable data types in FPT/SMT memo fields.;" +;
            "Under SIx 3.0, this feature has been expanded to ;" +;
            "include a completely new field type, 'V', which  ;" +;
            "supports efficient variable length data storage. ", lNoAlert )

SchmoozeBox("First, we'll look at storing different Clipper data ;" +;
            "types in a MEMO fields. Clipper's ValType() function;" +;
            "will return the type of the data that was stored.   ;", lNoAlert )

? "Create VARI.DBF with MEMO field 'TEST'.......: "
dbCreate( "VARI", aDBF )
?? iif( file("VARI.DBF") .and. file("VARI" + MEMOEXT ), "OK", "ERROR" )

? "USE VARI and APPEND five blank five records .: "
USE vari
FOR nX := 1 to 5
  dbAppend()
NEXT
?? iif( LastRec()==5, "OK", "ERROR" )

GO TOP

? 'Store CHARACTER value "Hello" to record 1 ...: '
vari->TEST := "Hello"
?? "OK"
dbSkip()

? 'Store NUMERIC value 12345 to record 2 .......: '
vari->TEST := 12345
?? "OK"
dbSkip()

? 'Store LOGICAL value .T. to record 3 .........: '
vari->TEST := .T.
?? "OK"
dbSkip()

? 'Store DATE value CTOD("01/31/93") to record 4: '
vari->TEST := CTOD("01/31/93")
?? "OK"
dbSkip()

? 'Store ARRAY value {1,2,3,{1,2,3}} to record 5: '
vari->TEST := {1,2,3,{1,2,3}}
?? "OK"


?
? "Now, to validate the values, we'll execute this piece of code:"
?
? ' GO TOP'
? ' DO WHILE !eof()'
? '   ? " Record " + LTrim( Str( Recno() )) + ": " + ValType( vari->TEST )'
? '   dbSkip()'
? ' ENDDO'
? "--------------------------------"
GO TOP
DO WHILE !eof()
  ? " Record " + LTrim( Str( Recno() )) + ": " + ValType( vari->TEST )
  dbSkip()
ENDDO
?
wait
CLOSE ALL
CLS

// Perform clean-up
fErase( "VARI.DBF" )
fErase( "VARI" + MEMOEXT )


SchmoozeBox("Next, we'll see how the OTTO utility can help you ;" +;
            "convert your existing data files to use the new   ;" +;
            "'V' fields for more efficient data storage.       ;;" +;
            "There are strongly-typed 'V' fields (DATE and INT);" +;
            "and weakly-typed 'V' fields (Variable type/len).  ", lNoAlert )

? "Copying TEST.DBF to VTEST.DBF for test..."
COPY FILE test.dbf TO vtest.dbf
?? "Done!"

Otto( "VTEST.DBF" )

// Perform clean-up
fErase( "VTEST.DBK" )
fErase( "VTEST.DBF" )
fErase( "VTEST" + MEMOEXT )


Return(NIL)


/*
 ͸
   HiPer-SEEK Indexes & Filters                                            
 ;
*/

FUNC SIx_HiPerSEEK( lNoAlert )

CLS
MyAlert("HiPer-SEEK Indexes & Filters")

SchmoozeBox("After opening the TEST.DBF file, we'll use;" +;
            "hs_Index() function to create a HiPer-SEEK;" +;
            "index file on the FIRST, LAST, STREET, and;" +;
            "CITY fields.  Then we'll be able to search;" +;
            "for all records containing any one of the ;" +;
            "specified substrings of text within any of;" +;
            "these four fields.                        ", lNoAlert )

hsFilt()

Return(NIL)


/*
 ͸
   Record RollBacks                                                        
 ;
*/

FUNC SIx_RollBack( lNoAlert )

CLS
MyAlert("Record Edit Rollbacks")

SchmoozeBox("You  can get rid of all of your  SCATTER/GATHER;" +;
      "code and just add the following code after  the;" +;
      "READ to do record rollbacks:                   ;;"+;
      "   IF LastKey() == K_ESC                       ;" +;
      "     Sx_RollBack()                             ;" +;
      "   ENDIF                                       ;;"+;
      "Here's a practical example of this in action...", lNoAlert)

RollBack()

Return(NIL)

/*
 ͸
   Logical Index Key Position Functions                                    
 ;
*/

FUNC SIx_LogicalKey( lNoAlert )

CLS
MyAlert("Logical Key Index Position Information")
SchmoozeBox("This shows how you can use the Sx_KeyNo();" +;
      "and Sx_KeyCount() functions to access key;" +;
      "position information and a scroll bar for;" +;
      "your browse windows.                     ;;"+;
      "These  functions do for indexes what  the;" +;
      "Recno()  and  RecCount() functions do for;" +;
      "databases!                               ", lNoAlert )

CLOSE ALL
ScrollBar()

Return(NIL)

/*
 ķ
  Memo Files                                                               
 Ľ
*/

FUNC SIx_Memo( aMemo, lNoAlert )

LOCAL nX := 0

CLS
MyAlert( MEMOEXT + " Memo File Features")

FOR nX := 1 TO Len( aMemo )
  iif( aMemo[nX,1] == "", eval( aMemo[nX,3] ), NIL )
NEXT

Return(NIL)


/*
 ķ
  Data/File Compression                                                    
 Ľ
*/

FUNC SIx_Compress( lNoAlert )

LOCAL aFile := {}

CLS
CLOSE ALL
MyAlert("Data/File Compression")

? "Compressing TEST500.DBF to TEST500.CMP...: "

?? if( Sx_FCompress( "TEST500.DBF", "TEST500.CMP" ), "DONE", "ERROR" )

?
aFile := Directory("TEST500.DBF")
? "TEST500.DBF: " + AllTrim( Str( aFile[ 1, F_SIZE ] )) + " Bytes"
aFile := Directory("TEST500.CMP")
? "TEST500.CMP: " + AllTrim( Str( aFile[ 1, F_SIZE ] )) + " Bytes"
?
fErase( "TEST500.CMP" )
wait

Return(NIL)


/*
 ķ
  Data/File Encryption                                                     
 Ľ
*/

FUNC SIx_Encrypt( lNoAlert )

LOCAL cPassWord := Space(8), nCurs := 0, GetList := {}

CLS
MyAlert("Data/File Encryption")
USE test EXCL
SchmoozeBox("Press any key to view the unencrypted database...", lNoAlert )
Browse()
CLS
SchmoozeBox("Now we'll encrypt the entire database...", lNoAlert )
nCurs := SetCursor(1)
@ 0,0 SAY "Enter Password To Use For Encryption: " GET cPassWord
READ
SetCursor( nCurs )

cPassWord := AllTrim( cPassWord )

CLS
? "Encrypting TEST.DBF: "
?? iif( Sx_DBFencrypt( cPassWord ), "OK", "ERROR" )
Browse()
CLS
SchmoozeBox( "Since the file was opened with the correct password,;" +;
             "the data doesn't look encrypted in the browse.  Now,;" +;
             "we'll reopen the database using an incorrect pass-  ;" +;
             "word and see what an unauthorized user would see... ", lNoAlert )
CLOSE ALL
USE TEST EXCL
Browse()

SchmoozeBox( "Now we'll decrypt the database...", lNoAlert )
CLS
CLOSE ALL
USE TEST PASSWORD cPassWord EXCL
? "Decrypting TEST.DBF: "
?? iif( Sx_DBFdecrypt(), "OK", "ERROR" )
CLS
CLOSE ALL
USE TEST EXCL
Browse()

Return(NIL)


/*
 ķ
  Database Triggers                                                        
 Ľ
*/

FUNC SIx_Triggers( lNoAlert )

CLS
MyAlert("Database Triggers")
TrigDemo()
SchmoozeBox( "See the RECYCLE.PRG sample program for an;" +;
             "example of using Database Event Triggers ;" +;
             "to perform automatic record recycling.   ", lNoAlert )

Return(NIL)

/*
 ķ
  Data Dictionary (.INI) Files                                             
 Ľ
*/

FUNC SIx_DBINI( lNoAlert )

CLS
MyAlert("Data Dictionary Support (.INI Files)")
IniDemo()

Return(NIL)

/*
 ķ
  Miscellaneous Stuff                                                      
 Ľ
*/

FUNC SIx_Misc( lNoAlert )

CLS
MyAlert("Miscellaneous Stuff")
MyAlert("Other SIx Driver Features;" +;
        ";" +;
        "   Wildcard SEEKs                      ;" +;
        "   TURBOREAD                           ;" +;
        "   FoxPro Record Locking (SIXCDX Only) ;" +;
        "   International Support               ;" +;
        "   INDEX ON ... ADDITIVE               ;" +;
        "   Transaction Locking                 ")

Return(NIL)


/*
 ķ
  Mach SIx Query Optimizer                                                 
 Ľ
*/

FUNC SIx_MachSIx( lNoAlert )

CLS
MyAlert("The Mach SIx Query Optimizer")

fErase( "TEST5K" + INDEXEXT )
M6Demo()
fErase( "TEST5K" + INDEXEXT )

MyAlert( "And now for something COMPLETELY different..." )

MyAlert("Roll-Your-Own (RYO) Filter Demo")

MyAlert("The following demo might look familiar.  It's the ;"+;
        "same one used in our RYO index demo but has been  ;"+;
        "modified to work with MachSIx's RYO filter system." )

fErase( "TEST" + INDEXEXT )
RYOFilt()

Return(NIL)


/*
 ķ
  Smaller Than DBT Memos                                                   
 Ľ
*/

FUNC Mem_Convert( lNoAlert )

CLS
SchmoozeBox("Converting your existing .DBT files into " + MEMOEXT + "s can;" +;
      "be easily done using a simple USE/COPY program.  ;;" +;
      "Let's convert a 500-record .DBF/.DBT file combo into;" +;
      "a .DBF/" + MEMOEXT + " combo using the MEMOCONV program...", lNoAlert )

// Make sure a structural index file from a previous demo isn't lurking...
CLOSE ALL
fErase("TEST" + INDEXEXT )

SetColor("bg+/n")
CLS

MemoConv( "TESTOLD", "TESTNEW" )
WAIT
fErase( "TESTNEW.DBF" )
fErase( "TESTNEW" + MEMOEXT )

SchmoozeBox("Wow!  That's a serious space savings!", lNoAlert)
SetColor("bg+/b")
CLS

#ifdef CDX
SchmoozeBox("Same data, less wasted space!  What a deal!;" +;
            "This is because .FPT memo files default to ;" +;
            "32 byte memo blocks.  (As compared to .DBT ;" +;
            "file's fatter 512 byte memo blocks!)       ", lNoAlert )
#else
SchmoozeBox("Same data, less wasted space!  What a deal!;" +;
            "This is because .SMT memo files default to ;" +;
            "1 byte memo blocks.  (As compared to .DBT  ;" +;
            "file's fatter 512 byte memo blocks!)       ", lNoAlert )
#endif

Return(NIL)


/*
 ķ
  Block Size Adjustments                                                   
 Ľ
*/

FUNC Mem_BlockSize( lNoAlert )

CLS
SchmoozeBox("The SIx Driver allows you to adjust the " + MEMOEXT + " memo;" +;
            "block size to any value between 1 and 1024 bytes.", lNoAlert )

Return(NIL)

/*
 ķ
  Reuse Of Freed Blocks                                                    
 Ľ
*/

FUNC Mem_FreeBlocks( lNoAlert )

MEMVAR GetList

CLS
SchmoozeBox("SIx Driver " + MEMOEXT + " files reuse freed memo ;" +;
            "blocks automatically!  This means that ;" +;
            "old, freed blocks are reused before any;" +;
            "new blocks of data are blindly added to;" +;
            "the bottom of the memo file.           ;;" +;
            "Say goodbye to memo-bloat!!!", lNoAlert )

Return(NIL)

/*
 ķ
  Memo Packing                                                             
 Ľ
*/

FUNC Mem_Pack( lNoAlert )

CLS
MyAlert( MEMOEXT + " Memo Packing" )
SchmoozeBox("The SIx Driver allows you to PACK the " + MEMOEXT + " memo;" +;
            "file independant of the DBF file.  This removes;" +;
            "all freed blocks from the " + MEMOEXT + " memo file.      ", lNoAlert )

Return(NIL)

