/*
  ķ
                                                                         
   Program...: SIXTRIG.PRG                                               
   Author....: Team SuccessWare                                          
   Notice....: Copyright 1993-95 - SuccessWare 90, Inc.                  
                                                                         
   Purpose...: This is the complete source for the _default_             
               Sx_DefTrigger() function, as it appears in the SIX3.LIB   
               file.                                                     
                                                                         
               As written, it simply unloads itself as soon as the file  
               is USE'd.  Comment out (or remove) the                    
               Sx_SetTrigger( TRIGGER_REMOVE ) line under the            
               EVENT_PREUSE case to allow you to add additional event-   
               handling operations.                                      
                                                                         
               Uncomment the _sxINIinit() call if you will be using the  
               SIx Driver's Data Dictionary functions.                   
                                                                         
   Compile...: CLIPPER sixtrig /n /w /dNSX    // For SIXNSX (default)    
             : CLIPPER sixtrig /n /w /dCDX    // For SIXCDX              
                                                                         
  Ľ
*/

#ifdef CDX
  #include "SIXCDX.CH"
#else
  #include "SIXNSX.CH"
#endif

FUNC Sx_DefTrigger( nEvent, nArea, nFieldPos, xTrigVal )

  DO CASE

    CASE nEvent == EVENT_PREUSE
//    _sx_INIinit( nArea )
      Sx_SetTrigger( TRIGGER_REMOVE )

    CASE nEvent == EVENT_POSTUSE

    CASE nEvent == EVENT_UPDATE

    CASE nEvent == EVENT_APPEND

    CASE nEvent == EVENT_DELETE

    CASE nEvent == EVENT_RECALL

    CASE nEvent == EVENT_PACK

    CASE nEvent == EVENT_ZAP

    CASE nEvent == EVENT_PUT

    CASE nEvent == EVENT_GET

    CASE nEvent == EVENT_PRECLOSE

    CASE nEvent == EVENT_POSTCLOSE

    CASE nEvent == EVENT_PREMEMOPACK

    CASE nEvent == EVENT_POSTMEMOPACK

  ENDCASE

Return( .T. )

