/*
  ķ
                                                                         
   Program...: VFDEMO.PRG                                                
   Author....: Team SuccessWare                                          
   Notice....: Copyright 1995 - SuccessWare 90, Inc.                     
   Purpose...: Demonstrates using the SIx Driver's VariField "V" fields  
               in a data input (GET/READ) screen.                        
                                                                         
   Compile...: CLIPPER vfdemo /w /n  (for SIXCDX)                        
                                                                         
   Link......: BLINKER FI vfdemo,sixcdx @six3  (for SIXCDX)              
           or: BLINKER FI vfdemo,sixnsx @six3  (for SIXNSX)              
                                                                         
   NOTE:  This example creates it's own database files.                  
                                                                         
  Ľ
*/

#ifdef CDX
  #include "SIXCDX.CH"
#else
  #include "SIXNSX.CH"
#endif


FUNC VFDemo()

LOCAL cOldColor := SetColor( "w+/b,b/w,,,n/bg" )
LOCAL cFirst := Space(20), cLast := Space(20)
LOCAL GetList := {}

CLS

dbCreate( "VFTEST", {{"FIRST","C",20,0},{"LAST","C",20,0}} )
USE vftest EXCL
dbAppend()
vftest->FIRST := "Homer"
vftest->LAST  := "Simpson"
GO TOP

Alert( "First, a standard @...SAY...GET using;" +;
       "20 character-wide CHARACTER fields..." )

@ 6, 2 SAY "---------------------------   --------------------------"
@ 5, 2 SAY "First:" GET vftest->FIRST
@ 5,32 SAY "Last:"  GET vftest->LAST
READ

CLOSE ALL

Alert( "Now, the same @...SAY...GET using a 5   ;" +;
       "byte-significant 'V' field for the FIRST;" +;
       "name field and a 10 byte-significant 'V';" +;
       "field for the LAST name field...        " )

dbCreate( "VFTEST", {{"FIRST","V",11,0},{"LAST","V",16,0}} )
USE vftest EXCL
dbAppend()
vftest->FIRST := "Homer"
vftest->LAST  := "Simpson"
GO TOP


@10, 2 SAY "---------------------------   --------------------------"
@ 9, 2 SAY "First:" GET vftest->FIRST
@ 9,32 SAY "Last:"  GET vftest->LAST
READ


Alert( "To emulate the old, standard format, ;" +;
       "use a SCATTER/GATHER, padding the    ;" +;
       "SCATTER value as it's read from the  ;" +;
       "database file into the temp variable." )

cFirst := PadR( vftest->FIRST, 20 )
cLast  := PadR( vftest->LAST, 20 )

@14, 2 SAY "---------------------------   --------------------------"
@13, 2 SAY "First:" GET cFirst
@13,32 SAY "Last:"  GET cLast
READ

SetColor( cOldColor )

Return(NIL)

