/************************************
 *
 *
 *   Description: Test programm for sixcld
 *     File Name: Test6CLD.prg
 *        Author: Dieter Crispien
 *  Date created: 03/15/95
 *     Link     : Blinker FI Test6CLD, sixtools @6cld out T6cld
 *     Make File: RMake Test6CLD.RMK
 *     Exec File: T6CLD.EXE
 *
 *
 *     Comment  : A lot of stuff borrowed <g> from Loren's examples
 *
 *                Tested using the following versions:
 *                Clipper 5.2d (German!)
 *                SIx 3.00.00 (dated 03/15/95, 05:20)
 *                other stuff I can't talk about as of today
 *************************************/

#define NSX

#include "SIXNSX.CH"
REQUEST SIXCDX
REQUEST SIXNTX
//REQUEST DBFNTX

#define INDEXEXT ".NSX"

#include "inkey.ch"
#include "box.ch"
#include "obsolete.ch"

#define CRLF  CHR(13) + CHR(10)
#define T 5
#define L 5
#define B (T + 7)
#define R (maxcol()-25)
#define BT  3
#define BL  10
#define BB  (maxrow()-7)
#define BR  (maxcol()-5)
#define MT  (maxrow()-6)
#define ML  15
#define MB  (maxrow()-1)
#define MR  (maxcol()-15)
#xtrans  writeString(<string>,<handle>)  => ;
         fwrite( <handle>,(<string>),len(<string>) ) == len(<string>)
#xtrans  isTrue(<cStr>)      => ("*"+upper(<cStr>)+"*" $ "*.T.*TRUE*ON*YES*" )
#xtrans  isFalse(<cStr>)     => ("*"+upper(<cStr>)+"*" $ "*.F.*FALSE*OFF*NO*")


*request sx_tableType, sx_indexType

field first,last,state,married,salary,age


/*****
 *
 *         Name: Test6CLD()
 *  Description: Main Routine
 *       Author: Dieter Crispien
 * Date created:
 *****************************************************/

procedure test6cld
   local nChoice, GetList := {}, aTemp := array(11)
   local cArrdbf
   local nEmptySelect
   // ͻ
   //  Welcome to SIxCLD 2.0                               
   //                                                      
   //  Press f5 and Test6CLD will generate some indexes    
   //  and after that it'll bring you back to cld.         
   //  you'll get more instructions.                       
   // ͼ
   altd()
   set exclusive on           // no rlock()'s required...

   // check for databases
   clear

   // make sixnsx the default
   RDDSetDefault( "SIXNSX" )

if !file( "TAGTEST.dbf"  ) .or. !file( "INITEST.dbf" )  .or. ;
   !file( "CRYPTEST.dbf" ) .or. !file( "COMPTEST.dbf" ) .or. ;
   !file( "TRIGTEST.dbf" ) .or. !file( "ARRTEST.dbf" ) .or.  ;
   !file( "SNTXTEST.dbf") .or. !file( "TEST.dbf")
   alert ("Some files are missing. Run MakeDBF.bat")
endif

if !file("COMPTEST.CMP")
  ? "Compressing CompTest.dbf to CompTest.cmp...: "

  ?? if( sx_FCompress( "CompTest.dbf", "CompTest.cmp" ), "done", "error" )
endif

// let's use one with the dbfntx driver
// if you want to activate the following line, you have to REQUEST DBFNTX!!!
// use NTXTEST via "dbfntx" new


// ============================================
// test the SIXNTX driver
// ============================================
use SNTXTest via "SIXNTX" new
index on state+upper(last) to SNTXTest


// ============================================
// test for order bags
// ============================================
use TagTest new

// ============================================
// for testing the trigger features
// ============================================
use IniTest via "SIXCDX" trigger "testtrigger" new

// ============================================
// for testing the encryption stuff
// the following is for testing encryption
// especially in the SIxCLD browse window
// We're using an incorrect password _ON PURPOSE_
// ============================================
use CrypTest password "xxx" excl new


// this will closed again before entering the debugger
use test new

// ============================================
// test for retrieving info on compressed data
// ============================================
use CompTest new

#ifdef testgerman
   index on last to Comp    for state == "BR"
#else
  index on last to Comp    for state == "CA"
#endif

dbgotop()    // move record pointer. State may not match order for condition!!

if !file("COMPTEST.nsx")
   index on COMPTEST->last  tag last to COMPTEST
endif

set index to CompTest
set order to tag last of CompTest
dbgoto(10)   // move record pointer. State may not match order for condition!!


use TrigTest trigger "customtrig" new

// ============================================
// test for the array browsing features of SIxCLD
// ============================================
// you should also test with the following line activated
// watch out to set a similar path correctly
*carrdbf := "d:\cl52d\sixcld\6cld110\testarr.dbf"
cArrDBF := "ArrTest.dbf"

use (cArrDBF) new alias ArrayTest
aTemp := dbstruct()
ArrayTest->notes := aTemp
dbskip()
ArrayTest->notes := date()
dbskip()
ArrayTest->notes := 12
dbskip()
ArrayTest->notes := "testing string in memo"

if !file("ArrTest.nsx")
   index on ArrayTest->state      tag state to ArrTest
endif
set index to ArrTest
set order to tag state of ArrTest
dbgoto(3)    // move record pointer. State may not match order for condition!!

select test                          // for testing
use                                  // we close one
nEmptySelect := select()


dbSelectArea("TagTest")
if !file("TestTag1.nsx")
   index on TagTest->last       tag last to TestTag1
#ifdef testgerman
   index on TagTest->first      tag first to TestTag1 for state == "BR"
#else
   index on TagTest->first      tag first to testtag1 for state == "CA"
#endif
   index on TagTest->state      tag state to testtag1 for salary > 100000
endif
if !file("TestTag2.nsx")
   index on TagTest->salary     tag salary to TestTag2
   index on TagTest->first      tag first to TestTag2 for age < 35
   index on TagTest->state+upper(last) tag state  to TestTag2 for !married
endif
   delete all for ( recno() % 3 == 0 )
   set index to testtag1, testtag2
   set order to "state" in TestTag1
   set scopetop to "ca"
   set scopebottom to "da"
   set relation to state into ArrayTest
   set relation to last into CompTest additive
   dbgoto(3)

   // ͻ
   //  Press F6 while in CLD and see what it does!         
   // ͼ
   altd()
   select (nEmptySelect)



   // ͻ
   //  Press F6 again. This work area has no dbf in use!   
   // ͼ
   altd()
   close databases




   // ͻ
   //  Press F6 again. No database in use!                 
   // ͼ
   altd()
   wait "This is the end (not by Jim Morrison)"
   return

/*

  The following two functions are unmodified copies from trigdemo.prg
  that comes with SIx 3.0

*/
//----------------------------------------------------------//
FUNC CustomTrig( nEvent, nArea, nFieldPos, xTrigVal )

LOCAL nKey := 0
FIELD last,age

DO CASE

  CASE nEvent == EVENT_PREUSE
    MessageBox( "EVENT_PREUSE", "Opening " + xTrigVal, .F. )

  CASE nEvent == EVENT_POSTUSE
    MessageBox( "EVENT_POSTUSE", "Looking for indexes...", .F. )
    MessageBox( "   TEST2" + INDEXEXT, "", .F. )
    IF file("TEST2" + INDEXEXT)
      MessageBox( "   Found", "Opening and Setting Active Tag To LAST...", .F. )
      SET INDEX TO test2        // Select TEST2 index
      SET TAG TO last           // Set LAST tag as active order
    ELSE
      MessageBox( "   Not Found", "Creating TAGs...", .F. )
      INDEX ON last TAG last OF TEST2 EVAL Odometer() EVERY 50
      INDEX ON age  TAG age  OF TEST2 EVAL Odometer() EVERY 50
      SET TAG TO last
    ENDIF
    MessageBox( "   Done!","(Try doing some DELETES and EDITS...)", .F. )

  CASE nEvent == EVENT_UPDATE

  CASE nEvent == EVENT_APPEND
    Return( MessageBox( "EVENT_APPEND", "Verifying...", .T. ))

  CASE nEvent == EVENT_DELETE
    Return( MessageBox( "EVENT_DELETE", "Verifying...", .T. ))

  CASE nEvent == EVENT_RECALL
    Return( MessageBox( "EVENT_RECALL", "Verifying...", .T. ))

  CASE nEvent == EVENT_PACK

  CASE nEvent == EVENT_ZAP

  CASE nEvent == EVENT_PUT
    Return( MessageBox( "EVENT_PUT", "Verifying...", .T. ))

  CASE nEvent == EVENT_GET

  CASE nEvent == EVENT_PRECLOSE
    IF ValType( xTrigVal )=="C"
      MessageBox( "EVENT_PRECLOSE", "Closing " + xTrigVal, .F. )
    ELSE
      MessageBox( "EVENT_PRECLOSE", "Closing All", .F. )
    ENDIF

  CASE nEvent == EVENT_POSTCLOSE
    MessageBox( "EVENT_POSTCLOSE", "Datafile(s) Closed", .F. )

  CASE nEvent == EVENT_PREMEMOPACK

  CASE nEvent == EVENT_POSTMEMOPACK

ENDCASE

Return( .T. )

//----------------------------------------------------------//
FUNC MessageBox( cStr1, cStr2, lVerify )

LOCAL nRow := MaxRow(), nCol := MaxCol(), cColor := SetColor("bg+/n")
LOCAL lRetVal := .T.

Scroll( nRow-6, 1, nRow-1, nCol-1, 1)
@ nRow-1, 2 SAY PadR( cStr1, 16 ) + ":" COLOR "gr+/n"
@ nRow-1,21 SAY cStr2 COLOR "bg+/n"
SetColor( cColor )

IF lVerify
  lRetVal := Alert( "Are you sure?", {"Yes","No"} )
ENDIF

Return( lRetVal )


function testTrigger(nEvent, nArea, nFieldPos, xTrigVal)
   local cExt
   do case
   case nEvent == EVENT_PREUSE
      _sx_INIInit( nArea )

      tableCheck(xTrigVal)

      /* if we know we are building index from scratch,
         erase the structural index before opening the database
      */
      if isTrue(sx_iniValue("GENERAL", "FORCE_REINDEX"))
      // Clip 5.2: cExt := iif( ordBagExt() == ".IDX", ".CDX", ordBagExt() )
                   cExt := indexExt()
         if file(xTrigVal+ cExt)
            ferase(xTrigVal+cExt)
         endif
      endif

   case nEvent == EVENT_POSTUSE
      iniCheck()                                 // if we don't have an ini file, write one
      idxCheck()                                 // check index tags
      msgBox("Browse our opened file...", .f., "R/W*")
   endcase
return( .T. )

function sx_IniValue( cHeader, cKey )
   local  nKey
   local aInfo_
      aInfo_ := sx_iniHeader( cHeader )
      if !empty(aInfo_)
         if ( nKey := ascan(aInfo_,{|a| valtype(a[1]) == "C" .and. upper(a[1]) == upper(cKey)}) ) > 0
            retu aInfo_[nKey,2]
         endif
      endif
return ""

//
function idxCheck()
   local aTags_ := sx_iniHeader( "INDEX" )
   local nLen := len( aTags_ ), i
   local asxtags_ := sx_tags()
   local cAlias := alias()

   if !empty(nLen)
      if empty(asxTags_)
         asxtags_ := array(nLen)
      else
         asize(asxtags_, nLen)
      endif

      if file(cAlias+".INI")
         msgBox({"Indexing information is missing...No problem! ",;
                 "Recreate indexes from information in the INI file."}, .f., "R/W*")
         showIni(cAlias+".INI", T,L,B,R)
         msgBox("Checking Indexes...", .f., "R/W*")

         for i := 1 to nLen
            if ascan( aSxTags_ , {|a| valtype(a)=="C" .and. upper(a)==upper( aTags_[i,1] )} ) == 0
               if lastrec()<=10
                  index on (aTags_[i,2]) tag (aTags_[i,1])
               else
                  index on (aTags_[i,2]) tag (aTags_[i,1]) eval odometer() every 10
               endif
            endif
         next
      endif
   endif
return nil

//
function msgBox(aStr, lPressKey, ccolor)
   local i, nRat
   static lStart := .f.
   static oldScr
   iif(lPressKey == NIL, lPressKey := .f., NIL)
   iif( ccolor==NIL, ccolor := "W+/R", NIL)
   if valtype(aStr)=="C"
      aStr := {aStr}
   endif

   if !lStart
      lStart := .t.
      oldScr := savescreen(MT, ML, MB, MR)
      dispbox(MT, ML, MB, MR, B_SINGLE+" ", "W+/R")
   endif

   if !aSTr==NIL
      dispbox(MT+1, ML+1, MB-1, MR-1, space(9), ccolor)
      for i := 1 to len(aStr)
         if len(astr[i]) > MR-MT-2
            if i == len(astr)
               aadd(astr, "")
            endif
            nRat := rat(" ", substr(astr[i], 1, MR-MT-2) )
            astr[i+1] := substr( astr[i], nRat + 1) + astr[i+1]
            astr[i] := substr( astr[i], 1, nRat - 1 )
         endif
         @ MT+i, ML+1 say padc(astr[i], MR-MT-2) color ccolor
      next
      if lPResskey
         @ MB-1, MR-13 say "<press key>" color "B+/W*"
         inkey(0)
         @ MB-1, MR-13 say "           " color ccolor
      endif
   else
      restScreen(MT, ML, MB, MR, oldScr)
      lStart := .f.
   endif
return nil

//
function tableCheck(cDbf)
   local aFields_, didCreate := .f.
   local oldScrn

   // should i need this line?
   // yes.
   // thanks.

   rddsetdefault("SIXNSX")
   if !file(cDbf+".DBF") .and. file(cDbf+".INI")
      msgBox({ cDbf + ".DBF" +" table was not found. Create it ",;
         "from these lines in the INI file."},.f., "R/W*")
      showIni(cDbf+".INI",T,L,B,R)
      aFields_ :=iniFields()
      dbCreate( cDbf, aFields_ )
      didCreate := .t.
   endif

return didCreate

//
static function showIni(cFile,nT,nL,nB,nR)
   local oldScr := saveScreen(nT,nL,nB,nR)
   local cStr := memoread(cfile), cTmp, nat, n
   dispbox(nT,nL,nB,nR,B_SINGLE+" ")
   @ nT, nL+2 say cfile
   for n := 1 to nB-nT-1
      cTmp := substr(cStr,1, (nat := at(CRLF,cStr))-1 )
      if !empty(cTmp)
         @nT +n, nL+1 say cTmp
      else
         exit
      endif
      cSTr := substr(cStr, nat+2)
   next
   inkey(0)
   restscreen( nT,nL,nB,nR, oldScr)
return nil

//
function iniCheck()
   local handle, aStru_, aIdx_, cTmp, nBytes, i, nlen, cFile := alias()

   if !file(cFile+".INI")
      msgBox({"INI file for "+ cfile+".DBF is missing. This INI file ",;
              "was created automatically when we opened the database."},.f., "R/W*")

      handle := fcreate(cFile+".INI")

      if handle > 0
         aSTru_   := dbstruct()
         nLen     := len(aStru_)
         nBytes   := writeString("[FIELDS]"+ CRLF , handle)
         for i := 1 to nLen
            nBytes := writeString(;
               padr(aStru_[i,1]      ,10) + " = "+;
               aStru_[i,2]           + " , "+;
               str( aStru_[i,3]         ) + " , "+;
               str( aStru_[i,4]         ) +  CRLF , handle)
         next
      endif
      fclose(handle)
      showIni(cFile+".INI",T,L,B,R)
   endif
return nil

function iniFields()
   local aFields_ := sx_iniHeader( "FIELDS" )
   local nLen     := len(aFields_), i, aStru := {}
   for i := 1 to nLen
      aadd(aStru, parseFieldInfo(aFields_[i,1]+"," + aFields_[i,2]))
   next
return aStru

//
function parseFieldInfo(cString)
   local aTokens_ := {}, nPtr
   cString  := ALLTRIM(cString)

   do  while (nPtr := at(",", cString)) != 0
      aadd(aTokens_, iif(nPtr > 1, rtrim(left(cString, nPtr-1)), ""))
      cString := iif(len(cString) > nPtr, ltrim(substr(cString, nPtr+1)), "")
   enddo

   aadd(aTokens_, cString)

   asize(aTokens_, 4)

   do case
   case  aTokens_[2] =="C"
      aTokens_[3] := val(aTokens_[3])
      aTokens_[4] := 0

   case  aTokens_[2] == "N"
      aTokens_[3] := val(aTokens_[3])
      if empty(aTokens_[4])
         aTokens_[4] := 0
      else
         aTokens_[4] := val(aTokens_[4])
      endif

   case  aTokens_[2] == "D"
      aTokens_[3] := 8
      aTokens_[4] := 0

   case  aTokens_[2] == "L"
      aTokens_[3] := 1
      aTokens_[4] := 0

   case  aTokens_[2] == "M"
      aTokens_[3] := 10
      aTokens_[4] := 0
   endcase
return aTokens_

